require 'omniauth-oauth'
require 'multi_json'
require 'gravatar-ultimate'

module OmniAuth
  module Strategies
    class Vocabulario < OmniAuth::Strategies::OAuth
      option :name, 'vocabulario'
      option :client_options, {:site => 'http://vocabulario.me'}
      
      uid do
        raw_info['id']
      end

      info do
        {
          :nickname => raw_info['permalink'],
          :name => raw_info['name'],
          :email => raw_info['email'],
          :image => Gravatar.new(raw_info['email']).image_url,
          :urls => {
            'Vocabulario' => 'http://vocabulario.me/users/' + raw_info['permalink']
          }
        }
      end

      extra do
        { :raw_info => raw_info }
      end

      def raw_info
        @raw_info ||= MultiJson.load(access_token.get('/users/current.json').body)['user']
      rescue ::Errno::ETIMEDOUT
        raise ::Timeout::Error
      end
    end
  end
end
